%% ARCS-FRAp̎gXNvg
%% 					Yuki YOKOKURA & Muto Hirotaka 2019/02/21
% g
% ARCSFRȂ{Cf[^DATA.csvɕۑ
%              
% ̃XNvgFRȂp[^ARCSƍ킹
%              
% DATA.csvǂݍݎs(ݒ肪Ă΃Ot\)

clc;
clear all;

%% FRȂp[^̐ݒ(@̃p[^ɍ킹)
FileName = '../DATA.csv';	% CSVt@C
Ts = 100e-6;% [s]  TvO
Fsta =  1;	% [Hz] Jng
Fend = 30;	% [Hz] Ig
Fstep = 0.5;% [Hz] gXebv
Ni = 10;	% [-]  ϕ
Au = 1;		% [-]  U
Bu = 0;		% [-]  oCAX
Tsta = 10;	% [s] FRAJn

%% gxNg
freq = Fsta:Fstep:Fend;
flen = length(freq);

%% @f[^ǂݍ
data = csvread(FileName);
t = data(:,1);     % [s]  
f = data(:,2);     % [Hz] g
iqref = data(:,3); % [A]  dwߒl
wmres = data(:,4); % [rad]x
clear data;

%% JnȑÕf[^폜O
t = t - Tsta;			% JnɃVtg
t(1:Tsta/Ts) = [];		% JnȑO͍폜
f(1:Tsta/Ts) = [];		% JnȑO͍폜
iqref(1:Tsta/Ts) = [];	% JnȑO͍폜
wmres(1:Tsta/Ts) = [];	% JnȑO͍폜
tlen = length(t);

%% f[^̕\
figure(1); set(gcf,'color',[1 1 1]);
subplot(3,1,1); plot(t,f);      %g̕ω
	xlabel('Time [s]','FontSize',14,'FontName','Times New Roman')
	ylabel('Frequency[rad/s]','FontSize',14,'FontName','Times New Roman')
	set(gca,'FontSize',14);
subplot(3,1,2); plot(t,iqref);  %͐M
	xlabel('Time [s]','FontSize',14,'FontName','Times New Roman')
	ylabel('Current[A]','FontSize',14,'FontName','Times New Roman')
	set(gca,'FontSize',14);
subplot(3,1,3); plot(t,wmres);  %o͐M
	xlabel('Time [s]','FontSize',14,'FontName','Times New Roman')
	ylabel('Position[m]','FontSize',14,'FontName','Times New Roman')
	set(gca,'FontSize',14);

%% FRǍvZ
y = wmres;
tini = 0;
Ar(1:flen) = 0;
Ai(1:flen) = 0;
j = 1;
for i=1:tlen-1,
	Ar(j) = Ar(j) + y(i)*cos(2*pi*f(i)*(t(i) - tini))*Ts;
	Ai(j) = Ai(j) + y(i)*sin(2*pi*f(i)*(t(i) - tini))*Ts;
	if(f(i) ~= f(i+1))
		if(j < flen)
			Ar(j) = 2*f(i)/Ni*Ar(j);
			Ai(j) = 2*f(i)/Ni*Ai(j);
			tini = t(i);
			j = j + 1;
		else
			break;
		end;
	end
end
%figure(127); plot(freq,Ar,'x-', freq,Ai,'x-');	% mFp

%% Ō̃f[^Ȃ̂ŏĂ
Ar(flen) = [];
Ai(flen) = [];
freq(flen) = [];
flen = length(freq);

%% ǧvZ
Ay = sqrt(Ar.^2 + Ai.^2);          % o͐UvZ
G = 20*log10(Ay./Au);              % QCvZ
P = unwrap(-atan2(Ai,Ar))*180/pi;  % ʑvZ

%% g̕`
figure(2); set(gcf,'color',[1 1 1]);
subplot(2,1,1); h=semilogx(freq,G,'x-');
	set(h,'linewidth',2);
	xlabel('Frequency [Hz]','FontName','Times New Roman','FontSize',14)
	ylabel('Gain [dB]','FontName','Times New Roman','FontSize',14)
	set(gca,'FontSize',14);
	xlim([Fsta,Fend])
	grid on;
subplot(2,1,2); h=semilogx(freq,P,'x-');
	set(h,'linewidth',2);
	xlabel('Frequency [Hz]','FontName','Times New Roman','FontSize',14)
	ylabel('Phase [deg]','FontName','Times New Roman','FontSize',14)
	set(gca,'FontSize',14);
	xlim([Fsta,Fend])
	grid on;

% EPSt@C([JŎŝ)
% print(gcf,'-depsc2','-tiff','DATA.eps');

